"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _mathArray = require("math-array");

var _sd = _interopRequireDefault(require("./sd"));

var _ma = _interopRequireDefault(require("./ma"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _default = function _default(datum) {
  var size = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 20;
  var times = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 2;

  var _ref = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {},
      avg = _ref.ma,
      sd = _ref.sd;

  avg = avg || (0, _ma["default"])(datum, size);
  sd = sd || (0, _sd["default"])(datum, size);
  var timesSd = (0, _mathArray.mul)(sd, times);
  return {
    upper: (0, _mathArray.add)(avg, timesSd),
    mid: avg,
    lower: (0, _mathArray.sub)(avg, timesSd)
  };
};

exports["default"] = _default;