"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.llv = exports.hhv = void 0;

// @param {Number} start index to start [
// @param {Number} end index less than )
// -> [start, end)
var reduce = function reduce(array, start, end, reducer) {
  var prev;
  var i = start;

  for (; i < end; i++) {
    if (i in array) {
      if (prev === undefined) {
        prev = array[i];
        continue;
      }

      prev = reducer(prev, array[i]);
    }
  }

  return prev;
};

var compare = function compare(data, size, comparer) {
  var length = data.length;

  if (size > length) {
    return Array(length);
  }

  if (size <= 1) {
    return data.slice();
  }

  var i = size - 1;
  var ret = [];

  for (; i < length; i++) {
    ret[i] = reduce(data, i - size + 1, i + 1, comparer);
  }

  return ret;
};

var hhv = function hhv(data, size) {
  return compare(data, size, function (a, b) {
    return Math.max(a, b);
  });
};

exports.hhv = hhv;

var llv = function llv(data, size) {
  return compare(data, size, function (a, b) {
    return Math.min(a, b);
  });
};

exports.llv = llv;