"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _common = require("./common");

// simple moving average
var _default = function _default(data, size) {
  var length = data.length;

  if (size <= 1) {
    return data.slice();
  }

  if (size > length) {
    return Array(length);
  }

  var prepare = size - 1;
  var ret = [];
  var sum = 0;
  var i = 0;
  var counter = 0;
  var datum;

  for (; i < length && counter < prepare; i++) {
    datum = data[i];

    if ((0, _common.isNumber)(datum)) {
      sum += datum;
      counter++;
    }
  }

  for (; i < length; i++) {
    datum = data[i];

    if ((0, _common.isNumber)(datum)) {
      sum += datum;
    }

    if ((0, _common.isNumber)(data[i - size])) {
      sum -= data[i - size];
    }

    ret[i] = sum / size;
  }

  return ret;
};

exports["default"] = _default;