"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _mathArray = require("math-array");

var _ema = _interopRequireDefault(require("./ema"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _default = function _default(data) {
  var slowPeriods = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 26;
  var fastPeriods = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 12;
  var signalPeriods = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 9;
  var MACD = (0, _mathArray.sub)((0, _ema["default"])(data, fastPeriods), (0, _ema["default"])(data, slowPeriods), 1);
  var signal = (0, _ema["default"])(MACD, signalPeriods);
  var histogram = (0, _mathArray.mul)(2, (0, _mathArray.sub)(MACD, signal), 1);
  return {
    MACD: MACD,
    signal: signal,
    histogram: histogram
  };
};

exports["default"] = _default;